; 
;/*
;    ###########################################################################
; 
;    "MUX version 1.0 (SPIN MUX)" - Copyright (C) 1996, Tibor Csoka (6505167273)
;
;
;    Software author, contact: csoka.tibor@gmail.com
;
;    ***************************************************************************
;     *                                                                       *
;     *   "MUX version 1.0 (SPIN MUX)" circuits diagram is available in pdf   *
;     *    Complete, revised, and edited pdf reference manuals are also       *
;     *    available.                                                         *
;     *                                                                       *
;     *                                                                       *
;     *             >>> See http://www.fanit.sk for details. <<<              *
;     *                                                                       *
;     *           Thank you for using "MUX version 1.0 (SPIN MUX)",           *
;     *                    and thank you for your support !                   *
;     *                                                                       *
;    ***************************************************************************
;
;
;    This file is part of the "MUX version 1.0 (SPIN MUX)" distribution.
;
;    "MUX version 1.0 (SPIN MUX)" is free software; you can redistribute it 
;    and/or modify it under the terms of the: 
;
;                "GNU General Public License (version 2)"
;    
;   as published by the Free Software Foundation AND MODIFIED BY the: 
;                 
;                 "MUX version 1.0 (SPIN MUX)" exception.
;
;    >>>NOTE<<< 
;    
;    "MUX version 1.0 (SPIN MUX)" is distributed in the hope that it will be
;    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;    Public License for more details. You should have received a copy of the
;    GNU General Public License and the "MUX version 1.0 (SPIN MUX)" license
;    exception along with "MUX version 1.0 (SPIN MUX)" if not, it can be viewed
;    here: http://www.fanit.sk.
;
;    1 tab == 4 spaces!
;
;    ###########################################################################
;*/
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;PROGRAM MULTIPLEXERA PRE SYSTEM =SPIN MUX=
;1- ADRESA 0000H, KANALY SU TESTOVANE cca. 0.240 s min. JEDEN KANAL (1.68 s VSETKY), 150 BIT/sekunda
;                                     cca. 0.400 s max. JEDEN KANAL (2.80 s VSETKY), 150 BIT/sekunda
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Autor : Ing. Tibor CSOKA, BRATISLAVA - SLOVENSKO, marec 1996.
;
DPLR      EQU     82H             ;DOLNY BYTE REGISTRA DPTR
DPHR      EQU     83H             ;HORNY BYTE REGISTRA DPTR
PCON      EQU     87H             ;ADRESA REGISTRA RIADENIA NAPAJANIA
R00       EQU     00H             ;R0 BANKA 0
R01       EQU     01H             ;R1 POMOCNE POCITADLO ADRIES (STATx,...)
KANPOC    EQU     02H             ;R2 POMOCNE POCITADLO 'KANAL MULTIPLEXERA'
R13       EQU     0BH             ;R3 BANKA 1, POCITADLO PRI PRACI S EEPROM
R14       EQU     0CH             ;R4 BANKA 1, POCITADLO PRI PRACI S EEPROM
R15       EQU     0DH             ;R5 BANKA 1, POCITADLO PRI PRACI S EEPROM
R16       EQU     0EH             ;R6 BANKA 1, POCITADLO PRI PRACI S EEPROM
R35       EQU     1DH             ;R5 BANKA 3, ADRESA 'EEPROM'
R36       EQU     1EH             ;R6 BANKA 3, ADRESA UDAJA EEPROM
R37       EQU     1FH             ;R7 BANKA 3, UDAJ DO/Z EEPROM
POC01     EQU     50              ;POCITADLO DOBY cca. 0.1 ms (0.1085 ms pri 11.059.200 Hz)
;
EEADR     EQU     0A0H            ;ADRESA PRVEJ PAMATE 'EEPROM'
POCPER    EQU     10H             ;R20 REGISTER
POC1L     EQU     11H             ;R21 REGISTER
POC1H     EQU     12H             ;R22 REGISTER
POC2L     EQU     13H             ;R23 REGISTER
POC2H     EQU     14H             ;R24 REGISTER
KANAL     EQU     15H             ;ADRESA PRE CISLO KANALu RETRANSLATORA
ERRORX    EQU     16H             ;PRIZNAK CHYBY PRI PRIJME Z RETRANSLATORA
BYTETX    EQU     17H             ;VYSIELANY BYTE DO RETRANSLATORA
BYTERX    EQU     18H             ;PRIJATY BYTE Z RETRANSLATORA
LONGBU    EQU     19H             ;DLZKA SPRAVY VYSIELANEJ Z 'PC'
LONRET    EQU     1AH             ;DLZKA SPRAVY VYSIELANEJ Z 'RET'
BCC       EQU     1BH             ;KONTROLNY SUCET PRE SPRAVY Z 'PC' A 'RET'
STAT1     EQU     20H             ;STAVOVY BYTE KANALU 1
STAT2     EQU     21H             ;STAVOVY BYTE KANALU 2
STAT3     EQU     22H             ;STAVOVY BYTE KANALU 3
STAT4     EQU     23H             ;STAVOVY BYTE KANALU 4
STAT5     EQU     24H             ;STAVOVY BYTE KANALU 5
STAT6     EQU     25H             ;STAVOVY BYTE KANALU 6
STAT7     EQU     26H             ;STAVOVY BYTE KANALU 7
STAT8     EQU     27H             ;STAVOVY BYTE KANALU 8
KANACK    EQU     28H             ;BITY POZIADAVIEK NA PRACU S 'KANALOM' A 'PC'
PCBUF     EQU     0000H           ;POCIATOCNA ADRESA PRIJIMACIEHO BUFFRA UDAJOV Z 'PC'
RETBUF    EQU     0100H           ;POCIATOCNA ADRESA PRIJIMACIEHO BUFFRA UDAJOV Z 'RET'
SPOC1L    EQU     01H             ;KONSTANTA 32 769 KRAT NASTANE PRERUSENIE PRE CAS 6.3 s.
SPOC1H    EQU     80H             ;KONSTANTA
MUX       EQU     0DDH            ;KONSTANTA - PRIZNAK AKTIVNEHO MUXu
T1SL      EQU     51H             ;KONSTANTA - CAS 1 sek. - 5200 KRAT NASTANE PRERUSENIE
T1SH      EQU     14H             ;KONSTANTA - CAS 1 sek.
T100ML    EQU     09H             ;KONSTANTA - CAS 100 ms - 521 KRAT NASTANE PRERUSENIE
T100MH    EQU     02H             ;KONSTANTA - CAS 100 ms
TGETL     EQU     0DH             ;KONSTANTA - CAS 150 ms - 781 KRAT NASTANE PRERUSENIE
TGETH     EQU     03H             ;KONSTANTA - CAS 150 ms
T300ML    EQU     19H             ;KONSTANTA - CAS 300 ms - 1561 KRAT NASTANE PRERUSENIE
T300MH    EQU     06H             ;KONSTANTA - CAS 300 ms
T500ML    EQU     2BH             ;KONSTANTA - CAS 500 ms - 2603 KRAT NASTANE PRERUSENIE
T500MH    EQU     0AH             ;KONSTANTA - CAS 500 ms
O10M      EQU     203             ;DOPLNOK POCITADLA DOBY CAKANIA 10 ms PRE PRERUSENIE
O30M      EQU     100             ;DOPLNOK POCITADLA DOBY CAKANIA 30 ms PRE PRERUSENIE
MAGIC     EQU     30ACH           ;KONSTANTA PRE ZABEZPECENIE 'LOGa'
ADLOGO	  EQU	  0020H		  ;POCIATOCNA ADRESA PRE VYPOCET ZABEZPECENIA LOGA
PTAMOK    EQU     0BAH            ;POZIADAVKA NA PRIRADENIE 'KZ' + TAMPER 'OK'
PTAMER    EQU     0BBH            ;POZIADAVKA NA PRIRADENIE 'KZ' + TAMPER 'ERROR'
;PRENOSOVE PARAMETRE PRE (148.73 - 153,11) BIT/sekunda
T1BIT     EQU     220             ;DOPLNOK - 35 POLPERIOD 2600Hz TRVANIA JEDNEHO BITU
T05L      EQU     11H             ;DOBA CAKANIA POLPERIODY JEDNEHO BITU
T05H      EQU     00H             ;DOBA CAKANIA POLPERIODY JEDNEHO BITU
T1BL      EQU     23H             ;DOBA CAKANIA PERIODU JEDNEHO BITU
T1BH      EQU     00H             ;DOBA CAKANIA PERIODU JEDNEHO BITU
;
PCYES     EQU     25H             ;KONSTANTA - ODPOVED NA AKTIVNY 'MUX' Z IBM PC
PCACK     EQU     27H             ;POTVRDENIE PRE 'PC' A Z 'PC'
PCNAK     EQU     29H             ;POTVRDENIE PRE 'PC' A Z 'PC'
ACK	  EQU     06H		  ;UDAJ PRE RIADENIE SER. LINKY RETRANSLATORA
NAK	  EQU	  15H		  ;UDAJ PRE RIADENIE SER. LINKY RETRANSLATORA
GETST     EQU     0B5H            ;POVEL Z 'MUX' NA ODOVZDANIE STAVU RETRANSLATORA
MUXACK    EQU     0C6H            ;POTVRDENIE Z 'MUX' DO 'RET'
MUXNAK    EQU     0D7H            ;CHYBA POTVRDENIA Z 'MUX' DO 'RET'
REACK     EQU     0EAH            ;POTVRDENIE Z 'RET' ZE PRIJIMACI BUFFER JE PRAZDNY
RENAK     EQU     0ECH            ;POTVRDENIE Z 'RET' ZE PRIJIMACI BUFFER JE PLNY
;
EN2600    EQU     29H.0           ;PRIZNAKOVY BIT PRE POVOLENIE CINNOSTI GEN. 2600 Hz
;
RX        EQU     P3.2            ;PIN PRIJIMACA DAT 2600 Hz
TX        EQU     P3.3            ;PIN VYSIELACA DAT 2600 Hz
TES       EQU     P3.4            ;PIN NASTAVUJUCI REZIM TESTOVANIA
INH       EQU     P3.5            ;INHIBIT PRE OBVOD 4051 - MULTIPLEXER
PA0       EQU     P1.0            ;A0 ADRESA PRE 4051
PA1       EQU     P1.1            ;A1 ADRESA PRE 4051
PA2       EQU     P1.2            ;A2 ADRESA PRE 4051
SIRENA    EQU     P1.3            ;EXTERNA SIGNALIZACIA = SIRENA + RED LED
LED       EQU     P1.4            ;ZELENA LED DIODA
STEP      EQU     P1.5            ;PIN UMOZNUJUCI KROKOVANIE V REZIME TESTOVANIA
PSDA      EQU     P1.6            ;DATA   PRE EEPROM
PSCL      EQU     P1.7            ;HODINY PRE EEPROM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ORG     0000H
STRT:   LJMP    RESTA           ;SKOK NA ZACIATOK HL.PROGRAMU
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;PRERUSENIE 'CASOVACA 0' POTREBUJE 4 BYTY ZASOBNIKA
        ORG     000BH           ;PRERUSENIE CASOVACA T0 - KAZDYCH 192 us
INTT0:  PUSH    PSW
        PUSH    ACC
        JB      EN2600,IS2600   ;KAZDYCH 192 us PRE GENEROVANIE 2600 Hz
        SETB    TX
        LJMP    INTGO
IS2600: CPL     TX              ;MODULUJ VYSTUP PRE GENEROVANIE 2600 Hz
INTGO:  INC     POCPER          ;ZVYS POCITADLO PERIOD
        MOV     A,POC1H         ;POCITADLO PRE VIAC AKO 5 s. (PRE KOD 'DD')
        JZ      JE1NUH
        MOV     A,POC1L
        JNZ     NO1NUL
        DEC     POC1H
        LJMP    NO1NUL
JE1NUH: MOV     A,POC1L
        JZ      TPOC2
NO1NUL: DEC     POC1L
TPOC2:  MOV     A,POC2H         ;POMOCNE POCITADLO CASU
        JZ      JE2NUH
        MOV     A,POC2L
        JNZ     NO2NUL
        DEC     POC2H
        LJMP    NO2NUL
JE2NUH: MOV     A,POC2L
        JZ      TPOC3
NO2NUL: DEC     POC2L
TPOC3:  POP     ACC
        POP     PSW
        RETI
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ORG     0060H
SPLOGO: DB      '################'
        DB      '#(C) T.CSOKA   #'
        DB      '#mux0000-v96/01#'
        DB      '################'
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TESTS:  NOP                     ;INICIALIZACNE TESTY
        MOV     P1,#0FFH        ;NASTAVENIE PORTU P1
        MOV     P3,#0FFH        ;NASTAVENIE PORTU P3
        MOV     A,#55H          ;TEST ACC
        CJNE    A,#55H,HALT1
        LJMP    NEWTST
HALT1:  CLR     SIRENA          ;ZAPNI SIRENU + RED LED, CHYBA HW
        CLR     LED             ;ZAPNI GREEN LED, CHYBA HW LEBO SVIETIA OBE DIODY
        LJMP    HALT1           ;OSTANE STAT PRI CHYBE !
NEWTST: CLR     LED             ;ZAPNI GREEN LED
        MOV     A,#0AAH
        CJNE    A,#0AAH,HALT1
        MOV     B,#55H          ;TEST 'B'
        MOV     A,B
        CJNE    A,#55H,HALT1
        MOV     B,#0AAH
        MOV     A,B
        CJNE    A,#0AAH,HALT1
        MOV     A,#00H
        MOV     R0,#55H         ;TEST R0
        MOV     A,R0
        CJNE    A,#55H,HALT1
        MOV     R0,#0AAH
        MOV     A,R0
        CJNE    A,#0AAH,HALT1
        MOV     R0,#7FH         ;TEST 128 BYTOV RWM INTERNEJ + VYNULUJ RWM
TST128: MOV     @R0,#55H
        MOV     A,@R0
        CJNE    A,#55H,HALT1
        MOV     @R0,#0AAH
        MOV     A,@R0
        CJNE    A,#0AAH,HALT1
        MOV     @R0,#00H
        MOV     A,@R0
        CJNE    A,#00H,HALT1
        DJNZ    R0,TST128
;
        MOV     DPTR,#00H       ;TEST EXTERNEJ RWM 32 KBYTE + VYNULOVANIE PAMATE
TOCRWM: MOV     A,#0AAH
        MOVX    @DPTR,A
        MOV     A,#00H
        MOVX    A,@DPTR
        CJNE    A,#0AAH,HALT1
        MOV     A,#055H
        MOVX    @DPTR,A
        MOV     A,#00H
        MOVX    A,@DPTR
        CJNE    A,#055H,HALT1
        MOV     A,#00H
        MOVX    @DPTR,A
        MOV     A,#0FFH
        MOVX    A,@DPTR
        CJNE    A,#00H,HALT1
        INC     DPTR
        ANL     DPHR,#7FH       ;'F' BIT JE STALE = 0 !!! (CE' RWM)
        MOV     A,DPLR          ;TEST CI SU OTESTOVANE VSETKY BYTY EXTERNEJ RWM
        ORL     A,DPHR
        JNZ     TOCRWM
;
ERLOGO: MOV     DPTR,#ADLOGO    ;TEST 'LOGO' AUTORA V ROM NA ADRESY <0020 - 009F> 128 BYTOV
        MOV     R0,#128         ;POCET TESTOVANYCH BYTOV LOGA
        MOV     R1,#00H         ;VYSLEDOK KONTROLY
        MOV     R2,#00H
TLOGO:  MOV     A,#00H
        MOVC    A,@A+DPTR
        ADD     A,R1
        MOV     R1,A
        MOV     A,#00H
        ADDC    A,R2
        MOV     R2,A
        INC     DPTR
        DJNZ    R0,TLOGO
        MOV     A,R1            ;TEST CI JE KONTROLNA SUMA V PORIADKU
        XRL     A,#LOW(MAGIC)
        JNZ     ERLOGO          ;OPAKUJ TEST AK JE CHYBA V 'LOGu' ROM
        MOV     A,R2
        XRL     A,#HIGH(MAGIC)
        JNZ     ERLOGO
        MOV     R1,#00H
        MOV     R2,#00H
;
        SETB    LED             ;VYPNI GREEN LED
        SETB    SIRENA          ;VYPNI RED LED + SIRENA
        MOV     SP,#30H         ;NASTAVENIE ZASOBNIKA 30H - 7FH ( max. 80 BYTOV )
        LJMP    EEPROM          ;SU PAMATE 'EEPROM' V PORIADKU
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;TEST 'EEPROM' PAMATI 4x512 BYTOV ALEBO 8x256 BYTOV
EETEST: NOP
        JNB     TES,ISTES       ;TESTUJ 'EEPROM' AK JE SKRATNUTY BIT TEST
        LJMP    OKETST
ISTES:  SETB    LED             ;VYPNI GREEN LED
        SETB    SIRENA          ;VYPNI RED LED + SIRENA
        MOV     R35,#EEADR      ;NASTAVENIE ADRESY PRVEJ 'EEPROM'
EKOL0:  MOV     R0,#0FFH        ;NASTAV POCITADLO NA 256 ADRIES
EKOL1:  MOV     R36,R0          ;ADRESA V 'EEPROM' DO R36
        CALL    READ            ;CITAJ OBSAH Z ADRESY (R36) 'EEPROM'
        MOV     B,R37           ;DOCASNE UCHOVAJ V 'B' REGISTRI
        MOV     R37,#0AAH       ;ZAPIS TESTOVANEHO UDAJA DO 'EEPROM'
        CALL    WRITE           ;ZAPIS DO 'EEPROM'
        MOV     R37,#00H
        CALL    READ            ;PRECITAJ ZAPISANY UDAJ PRE KONTROLU
        MOV     A,R37
        CJNE    A,#0AAH,EEZLE   ;POROVNAJ NACITANY OBSAH SO ZAPISOVANYM
        MOV     R37,#55H        ;TEST NA ZAPIS INVERZNEHO UDAJA
        CALL    WRITE
        MOV     R37,#00H
        CALL    READ
        MOV     A,R37
        CJNE    A,#55H,EEZLE
        MOV     R37,B           ;OBNOV POVODNY OBSAH 'EEPROM'
        CALL    WRITE
        MOV     A,R0
        JZ      JENULA
        DEC     R0
        LJMP    EKOL1
JENULA: MOV     A,R35           ;DO R35 NASTAV PLATNU ADRESU DALSEJ 'EEPROM'
        ANL     A,#0EH
        CJNE    A,#0EH,NOALL    ;TEST CI SU OTESTOVANE VSETKY 'EEPROM'
        LJMP    OKETST          ;SKOK AK SU OTESTOVANE !
NOALL:  ADD     A,#02H          ;NASTAV DALSIU ADRESU 'EEPROM' PRE TESTOVANIE
        ANL     A,#0EH
        ORL     A,#EEADR
        MOV     R35,A           ;NASTAV ADRESU OBLASTI 'EEPROM'
        CPL     LED             ;ZMEN STAV GREEN LED - DIODA POCAS TESTOVANIA EEPROM BLIKA
        LJMP    EKOL0
OKETST: SETB    LED             ;VYPNI DIODU GREEN LED
        SETB    SIRENA          ;VYPNI RED LED + SIRENA
        LJMP    INICI
EEZLE:  CLR     LED             ;ZAPNI GREEN LED - CHYBA HW
        CLR     SIRENA          ;ZAPNI SIRENU + RED LED, CHYBA HW LEBO SVIETIA OBE DIODY
        LJMP    EEZLE           ;PRI CHYBE ZOSTANE STAT V JEDNOM BODE PROGRAMU
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;INICIALIZACIA PARAMETROV PROGRAMU A uPROCESORA 80C31,87C51
; =SW=
INIC:   NOP                     ;INICIALIZACIA PARAMETROV SW A HW
        MOV     POCPER,#00H     ;NULUJ POCITADLO PERIOD 2600 Hz
        MOV     POC1L,#00H      ;NULUJ POCITADLO CASU 1
        MOV     POC1H,#00H
        MOV     POC2L,#00H      ;NULUJ POCITADLO CASU 2
        MOV     POC2H,#00H
        MOV     KANACK,#0FFH    ;NASTAV POZIADAVKY NA PRACU S 'KANALOM' A 'PC'
        MOV     STAT1,#00H      ;NULUJ STAVOVY BYTE KANALU 1
        MOV     STAT2,#00H      ;NULUJ STAVOVY BYTE KANALU 2
        MOV     STAT3,#00H      ;NULUJ STAVOVY BYTE KANALU 3
        MOV     STAT4,#00H      ;NULUJ STAVOVY BYTE KANALU 4
        MOV     STAT5,#00H      ;NULUJ STAVOVY BYTE KANALU 5
        MOV     STAT6,#00H      ;NULUJ STAVOVY BYTE KANALU 6
        MOV     STAT7,#00H      ;NULUJ STAVOVY BYTE KANALU 7
        MOV     STAT8,#00H      ;NULUJ STAVOVY BYTE KANALU 8
        MOV     KANAL,#00H      ;NASTAV POCITADLO 'KANAL'
        SETB    SIRENA          ;VYPNI SIRENU + RED LED
        SETB    LED             ;VYPNI GREEN LED
; =HW=
SETHW:  MOV     TMOD,#00100010B ;GATE1=0,C/T'=0,MOD1=2 ( 8 BIT AUTO)
                                ;GATE0=0,C/T'=0,MOD0=2 ( 8 BIT AUTO)
        MOV     TH1,#0FDH       ;8 BITOVY AUTOMATICKY OBNOVOVANY CITAC
        MOV     TL1,#0FDH       ;#0FDH => 9600 BIT/sekunda
        MOV     TH0,#79         ;8 BITOVY AUTOMATICKY OBNOVOVANY CITAC DOBY 192 us
        MOV     TL0,#79
        MOV     TCON,#01010101B ;TF1=0,TR1=1,TF0=0,TR0=1,IE1=0,IT1=1,IE0=0,IT0=1
        MOV     PCON,#00H       ;SMOD=0,GF1=GF0=0,PD=IDL=0
        MOV     SCON,#01010010B ;MOD=1(8 BIT),SM2=0,REN=1,TB8=RB8=0,TI=1,RI=0
        MOV     IP,#00000000B   ;0,0,PT2=0,PS=0,PT1=0,PX1=0,PT0=0,PX0=0 (PRIORITA[H,.,L] - PT1,IE0,PT0)
        MOV     IE,#10000010B   ;EA=1,0,ET2=0,ES=0,ET1=0,EX1=0,ET0=1,EX0=0
;
        LJMP    KOLO            ;NAVRAT DO HLAVNEHO PROGRAMU
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;PODPROGRAM NACITANIA UDAJA Z EEPROM
;( Adresa udaja je v R6 banky 3 RWM - R36, precitany udaj je
;umiestneny do R7 banky 3 RWM - R37, ADRESA AKTIVNEJ 'eeprom' JE
;V REGISTRI R35 = 1010xxx1B KDE xxx JE ADRESA 'EEPROM' )
; = POTREBUJE 4 BYTY ZASOBNIKA =
;
READ:	PUSH	PSW		;ULOZ ZASOBNIK
	PUSH	ACC		;ULOZ	A
        SETB    PSDA            ;PSDA=1
        SETB    PSCL            ;PSCL=1
	MOV	R13,#5		;POCITADLO PRE 10 us
	MOV	R14,#8		;POCITADLO BITOV
	MOV	R15,#2		;POCITADLO BAJTOV
	MOV	R16,#3		;POCITADLO BAJTOV RIADENIA
ST1:	DJNZ	R13,ST1		;CAKAJ cca 10 us
        MOV     A,R35           ;ADRESA 'EEPROM'
        ANL     A,#0FEH         ;POVEL NA ZAPIS ADRESY DO 'EEPROM'
BAJT4:	CLR	PSDA		;SDA=0  :  ZACIATOK START IMPULZU
	MOV	R13,#5
ST2:	DJNZ	R13,ST2		;10 us
	CLR	PSCL		;SCL=0   :  KONIEC STARTU
BAJT2:	MOV	R13,#5
ST3:	DJNZ	R13,ST3		;10 us
BAJT3:	RLC	A		;ZISTI HODNOTU VYSIELANEHO BITU
	JC	HOD1
	CLR	PSDA		;SDA=0
	LJMP	CHOD
HOD1:	SETB	PSDA		;SDA=1
CHOD:	MOV	R13,#5
ST4:	DJNZ	R13,ST4		;10 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
ST5:	DJNZ	R13,ST5		;10 us
	CLR	PSCL		;SCL=0
	DJNZ	R14,BAJT2	;SKOC AK NIE JE VYSLANY CELY BAJT
	MOV	R14,#8		;NASTAV POCITADLO BITOV
	MOV	R13,#10
ST6:	DJNZ	R13,ST6		;CAKAJ cca 20 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
ST7:	DJNZ	R13,ST7		;10 us
	JB	PSDA,CHYBA1	;TEST ACK'. NA SDA SKOC AK ACK=1 ( NESPRAVNE )
	CLR	PSCL		;SCL=0
	MOV	R13,#5
ST8:	DJNZ	R13,ST8
	MOV	A,R36		;DO 'A' ADRESU PRE CITANIE EEPROM
	DJNZ	R15,BAJT3	;VYSLANE PRVE DVA BAJTY ? NIE - SKOC !
	DJNZ	R16,POKROC	;SKOC AK NIE SU VSETKY RIADIACE BAJTY
	LJMP	CITA
POKROC:	MOV	A,R35   	;POVEL NA CITANIE EEPROM
        ORL     A,#01H
	MOV	R15,#1		;POCET NOVYCH BAJTOV
	SETB	PSDA		;SDA=1
	MOV	R13,#5
ST9:	DJNZ	R13,ST9		;10 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
ST10:	DJNZ	R13,ST10	;10 us
	DJNZ	R16,BAJT4	;SKOC AK NEBOLI ESTE VSETKY RIADIACE BAJTY
CITA:	MOV	R13,#5
ST11:	DJNZ	R13,ST11	;10 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
ST12:	DJNZ	R13,ST12	;10 us
	JB	PSDA,DATO1	;NACITANIE BITU Z BAJTU Z EEPROM
	CLR	C
	LJMP	CHOD2
DATO1:	SETB	C
CHOD2:	RLC	A		;DOCASNE ULOZENIE BAJTU Z EEPROM
	CLR	PSCL		;SCL=0
	MOV	R13,#5
ST13:	DJNZ	R13,ST13	;10 us
	DJNZ	R14,CITA
	SETB	PSDA		;SDA=1
	MOV	R13,#5
ST14:	DJNZ	R13,ST14	;10 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
ST15:	DJNZ	R13,ST15	;10 us
CHYBA1:	CLR	PSCL		;SCL=0
	MOV	R13,#5
ST16:	DJNZ	R13,ST16	;10 us
	CLR	PSDA		;SDA=0. ZACIATOK STOP.
	MOV	R13,#5
ST17:	DJNZ	R13,ST17	;10 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
ST18	DJNZ	R13,ST18	;10 us
	SETB	PSDA		;SDA=1.	 KONIEC STOP.
	MOV	R13,#25
ST19:	DJNZ	R13,ST19	;50 us
	MOV	R37,A		;OBSAH PAMATE DO R37
	POP	ACC		;OBNOV	A
	POP	PSW		;OBNOV	PSW
        RET                     ;NAVRAT Z PODPROGRAMU
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;PODPROGRAM PRE ZAPIS UDAJA DO EEPROM
;( Adresa udaja je v R6 banky 3 RWM - R36, zapisovany udaj je
;umiestneny v R7 banky 3 RWM - R37, ADRESA AKTIVNEJ 'eeprom' JE
;V REGISTRI R35 = 1010xxx0B KDE xxx JE ADRESA 'EEPROM' )
; = POTREBUJE 4 BYTY ZASOBNIKA =
;
WRITE:	PUSH	PSW		;UCHOVAJ PSW
	PUSH	ACC		;UCHOVAJ ACC
        SETB    PSDA            ;SDA=1
        SETB    PSCL            ;SCL=1
        MOV     A,R35           ;ADRESA 'EEPROM'
        ANL     A,#0FEH         ;POVEL PRE ZAPIS DO 'EEPROM'
	MOV	R13,#5
STOP1:	DJNZ	R13,STOP1	;10 us
	CLR	PSDA		;SDA=0
	MOV	R15,#3		;POCITADLO BAJTOV
	MOV	R14,#8		;POCITADLO BITOV
	MOV	R13,#5
STOP2:	DJNZ	R13,STOP2	;10 us
	CLR	PSCL		;SCL=0. START !
BAJT:	MOV	R13,#5
STOP3:	DJNZ	R13,STOP3	;10 us
BAJT1:	RLC	A		;DO 'C' VYSIELANY BIT
	JC	NAS1
	CLR	PSDA		;SDA=0
	SJMP	NAS2
NAS1:	SETB	PSDA		;SDA=1
NAS2:	MOV	R13,#5
STOP4:	DJNZ	R13,STOP4	;10 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
STOP5:	DJNZ	R13,STOP5	;10 us
	CLR	PSCL		;SCL=0
	DJNZ	R14,BAJT	;SKOC AK NIE JE VYSLANY CELY BAJT
	MOV	R13,#10
STOP6:	DJNZ	R13,STOP6	;20 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
STOP7:	DJNZ	R13,STOP7	;10 us
	JB	PSDA,CHYBA	;TEST ACK. NA SDA SKOC AK JE CHYBA !
	CLR	PSCL		;SCL=0
	MOV	R13,#5
STOP8:	DJNZ	R13,STOP8	;10 us
	MOV	A,R15
	CJNE	A,#3,ASI2	;KOLKO BAJTOV TREBA VYSLAT ?
	MOV	R14,#8		;NASTAV POCITADLO BITOV
	MOV	A,R36		;ADRESU EEPROM DO 'A'
	DJNZ	R15,BAJT1	;AK NIE SU VSETKY BAJTY SKOC !
	LJMP	KONI		;SKOC NA KONIEC
ASI2:	CJNE	A,#2,KONI	;SKOC AK SU VYSLANE VSETKY BAJTY
	MOV	R14,#8		;POCITADLO BITOV
	MOV	A,R37		;UDAJ PRE EEPROM DO 'A'
	DJNZ	R15,BAJT1
KONI:	CLR	PSDA		;SDA=0. ZACIATOK STOP.
	MOV	R13,#5
STOP9:	DJNZ	R13,STOP9	;10 us
	SETB	PSCL		;SCL=1
	MOV	R13,#5
STOP10:	DJNZ	R13,STOP10	;10 us
	SETB	PSDA		;SDA=1. KONIEC STOP.
	MOV	R13,#POC01	;CAKANIE WRITE CYKLU 12 ms
	MOV	R14,#120
STOP11:	DJNZ	R13,STOP11
	MOV	R13,#POC01
	DJNZ	R14,STOP11
	POP	ACC		;OBNOV	'A'
	POP	PSW		;OBNOV	PSW
        RET                     ;NAVRAT Z PODPROGRAMU
CHYBA:	CLR	PSCL		;SCL=0
	MOV	R13,#5
STOP12:	DJNZ	R13,STOP12	;10 us
	LJMP	KONI		;SKOC NA 'STOP' .
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
PROTOK: MOV     BYTETX,#GETST   ;KOMUNIKACNY PROTOKOL Z RETRANSLATOROM
        CALL    SETRET          ;NASTAV AKTIVNU LINKU RETRANSLATORA - KANAL
        CALL    TXBYTE          ;VYSLI VYZVU DO RET. ABY ODOVZDAL STATUS
        JB      RX,RXOK         ;TEST CI JE 'RX' V PORIADKU
ISER:   LJMP    PRTERR          ;SKOK AK JE CHYBA PRI KOMUNIKACNOM PROTOKOLE
RXOK:   MOV     POC2L,#TGETL    ;NASTAV CAS CAKANIA NA ODPOVED max. 150 ms + T(1 byte).
        MOV     POC2H,#TGETH
        CALL    RXBYTE          ;CAKAJ A NACITAJ BYTE Z RETRANSLATORA
        MOV     A,ERRORX        ;NACITAJ PRIZNAK CHYBY PRIJMU Z RET.
        XRL     A,#55H          ;55H=OK !  AAH=CHYBA !
        JNZ     ISER
        MOV     POCPER,#00H     ;CAKAJ cca. 30 ms NA USTALENIE PRIEBEHU 'RX'
W10MS1: MOV     A,#O30M         ;NASTAV POCITADLO ONESKORENIA ('ATU' MA maX. CAKACI INTERVAL 1.5s)
        ADD     A,POCPER
        JNC     W10MS1
        SETB    SIRENA          ;VYPNI SIRENU + RED LED
        JNB     RX,ISER         ;TEST CI JE 'RX' V PORIADKU
        MOV     A,BYTERX        ;NACITAJ PRIJATY STATUS
        ADD     A,#56H          ;TEST CI JE PRIJATY STATUS >= AAH
        JNC     ISBUF           ;SKOK AK IDE O PRENOS BUFFRA RETRANSLATORA
        CJNE    A,#PTAMOK,NTO   ;TEST CI IDE O POZIADAVKU PRIRADIT 'KZ
        LJMP    ISKAN           ;POZIADAVKU NA PRIRADENIE VZDY VYSIELA DO 'PC' !!!
NTO:    CJNE    A,#PTAMER,NTE
        LJMP    ISKAN           ;POZIADAVKU NA PRIRADENIE VZDY VYSIELA DO 'PC' !!!
NTE:    MOV     A,KANACK        ;TEST CI JE POZIADAVKA NA KOMUNIKACIU 'KANAL' S 'PC'
        MOV     KANPOC,KANAL
        CLR     C
ROT1:   RRC     A
        DJNZ    KANPOC,ROT1
        JC      ISKAN           ;SKOK AK JE POZIADAVKA KOMUNIKACIE (ZA VIAC AKO 5 s)
        MOV     R1,#STAT1       ;TEST CI NOVY STAV Z 'KANALu' JE ROVNAKY AKO PREDOSLY
        MOV     KANPOC,KANAL
        DEC     R1
ROT2:   INC     R1              ;NASTAV ADRESU STAVU PRISLUSNEHO KANALU
        DJNZ    KANPOC,ROT2
        MOV     A,@R1
        XRL     A,BYTERX
        JNZ     ISKAN           ;SKOK AK PRIJATY A PREDOSLY STAV SU ROZNE
        MOV     A,BYTERX        ;ULOZ NOVY STAV (TERAZ ROVNAKY AKO PREDOSLY)
        MOV     @R1,A
        MOV     BYTETX,#MUXNAK  ;UKONCI CAKACI STAV 'RET' NA ODPOVED Z 'MUX'
        CALL    TXBYTE          ;'RET' MOZE DALEJ TESTOVAT OBJEKTY - NECAKA ZBYTOCNE
        LJMP    NOKAN
ISKAN:  CALL    CLRKAN          ;NULUJ PRIZNAK KOMUNIKACIE 'KANAL' A 'PC', NASTAV STAV STATx
        CALL    TXSTAT          ;KOMUNIKACIA PRI PRIJATI STAVU RETRANSLATORA
        SETB    LED             ;ZHASNI GREEN LED. SVIETI LEN PRI PRENOSE DAT Z 'PC' DO 'RET'.
NOKAN:  LJMP    KOLO
ISBUF:  CALL    CLRKAN          ;NULUJ PRIZNAK KOMUNIKACIE 'KANAL' A 'PC'
        CALL    TXBUF           ;PRENOS BUFFRA RETRANSLATORA
        SETB    LED             ;ZHASNI GREEN LED. SVIETI LEN PRI PRENOSE DAT Z 'PC' DO 'RET'.
PRTERR: LJMP    KOLO
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
CLRKAN: MOV     A,KANACK        ;NULOVANIE POZIADAVKY NA KOMUNIKACIU 'KANAL' S 'PC'
        MOV     KANPOC,KANAL
        CLR     C
ROTX1:  RRC     A
        DJNZ    KANPOC,ROTX1
        CLR     C
        MOV     KANPOC,KANAL
ROTX2:  RLC     A
        DJNZ    KANPOC,ROTX2
        MOV     KANACK,A
        MOV     R1,#STAT1       ;NASTAV STARY STAV = NOVY STAV
        MOV     KANPOC,KANAL
        DEC     R1
ROTX3:  INC     R1
        DJNZ    KANPOC,ROTX3
        MOV     A,BYTERX
        ADD     A,#56H          ;TEST CI BOL PRIJEM SPRAVY Z 'ATU'
        JNC     BOLMSG
        MOV     A,BYTERX        ;BOL PRIJEM 'STAVU' 'ATU'
STULOZ: MOV     @R1,A
        RET
BOLMSG: MOV     A,#00H          ;PRE PRIPAD DALSEJ ROVNAKO DLHEJ SPRAVY PRIPRAV 'MUX'
        LJMP    STULOZ
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SETRET: MOV     B,KANAL         ;KANAL JE V INTERVALE (1 - 7)
        DEC     B               ;MODIFIKOVANY OBSAH NA (0 - 6)
        ANL     B,#07H
        MOV     A,P1            ;PODPROGRAM NASTAVI LINKU RETRANSLATORA PODLA CISLA
        ANL     A,#0F8H         ;V 'KANAL' UDAJI
        ORL     A,B
        XRL     A,#07H          ;INVERZIA BITOV ADRESY KANALU
        MOV     P1,A
        SETB    INH             ;POVOL INHIBIT OBVODU 4051- KANAL JE PRIEPUSTNY
        NOP                     ;USTALENIE SPOJENIA
        NOP
        NOP
        NOP
        NOP
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ASYNCHRONNY VYSIELAC BYTU - START,BIT0,BIT1,...,BIT7,STOP [,STOP]
TXBYTE: SETB    TX              ;PODPROGRAM VYSLANIA BYTU DO RETRANSLATORA (5 BYTOV 'STACK')
        CLR     EN2600          ;ZABLOKUJ GENERATOR 2600 Hz
        PUSH    R00             ;ULOZ DO ZASOBNIKA
        PUSH    PSW
        PUSH    ACC
        MOV     R0,#08H         ;NASTAV POCET VYSIELANYCH BITOV
        SETB    EN2600          ;GENERUJ 'START' BIT PRE xx BIT/SEKUNDA
        MOV     POCPER,#00H
TXST:   MOV     A,#T1BIT        ;TEST CI UPLYNULA DOBA JEDNEHO BITU
        ADD     A,POCPER
        JNC     TXST
ROTBIT: MOV     A,BYTETX        ;NACITAJ PRAVE VYSIELANY BIT
        RRC     A
        MOV     BYTETX,A        ;UCHOVAJ MODIFIKOVANY VYSIELANY BYTE
        JNC     ISNULA          ;TEST HODNOTY VYSIELANEHO BITU
        CLR     EN2600          ;ZASTAV GENERATOR 2600 Hz - BIT = 1 !
        LJMP    NEXT
ISNULA: SETB    EN2600          ;ZAPNI GENERATOR 2600 Hz - BIT = 0 !
NEXT:   MOV     POCPER,#00H
TXBIT:  MOV     A,#T1BIT        ;NASTAV CAS CAKANIA VYSLANIA JEDNEHO BITU
        ADD     A,POCPER
        JNC     TXBIT
        DJNZ    R0,ROTBIT       ;TEST CI JE VYSLANY CELY BYTE 'BYTETX' ?
        CLR     EN2600          ;VYPNI GENERATOR 2600 Hz
        SETB    TX
        MOV     POCPER,#00H     ;VYSLI 1 x 'STOP' BIT
TXSS:   MOV     A,#T1BIT
        ADD     A,POCPER
        JNC     TXSS
        LJMP    TXEND
        MOV     POCPER,#00H     ;VYSLI 1 x 'STOP' BIT
TXSS1:  MOV     A,#T1BIT
        ADD     A,POCPER
        JNC     TXSS1
TXEND:  POP     ACC             ;OBNOV UCHOVANE HODNOTY
        POP     PSW
        POP     R00
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ASYNCHRONNY PRIJIMAC BYTU START,BIT0,BIT1,...,BIT7,STOP
RXBYTE: PUSH    R00             ;PODPROGRAM PRIJMU BYTU Z RETRANSLATORA
        PUSH    PSW             ;S KONTROLOU max. CAKANIA NA PRIJEM 'START' BITU
        PUSH    ACC
        MOV     R0,#08H         ;NASTAV POCET PRIJIMANYCH BITOV
RXWAIT: MOV     A,POC2L         ;POCITADLO POC2 DRZI DOBU max. CAKANIA NA 'START'
        JNZ     NOER
        MOV     A,POC2H
        JNZ     NOER
STER:   LJMP    RXERR           ;SKOK NA NASTAVENIE PRIZNAKU CHYBNEHO PRIJMU !
NOER:   JB      RX,RXWAIT       ;TEST CI RX PIN = 1, CAKA NA 0=START !!!
        MOV     POC2L,#T05L     ;NASTAVENIE POLOVICNEJ DOBY TRVANIA BITU
        MOV     POC2H,#T05H
WAITR:  MOV     A,POC2L
        JNZ     WAITR
        MOV     A,POC2H
        JNZ     WAITR
        JB      RX,STER         ;SKOK AK JE CHYBA 'START' BITU = 1
OTBIT:  MOV     POC2L,#T1BL     ;NASTAVENIE DOBY TRVANIA JEDNEHO BITU
        MOV     POC2H,#T1BH
BITWAI: MOV     A,POC2L         ;VZORKOVANIE BITU JE V STREDE INTERVALU
        JNZ     BITWAI
        MOV     A,POC2H
        JNZ     BITWAI
        MOV     A,BYTERX        ;NACITAJ PRIJIMANY BYTE
        CLR     C
        JNB     RX,NO1RX        ;TEST HODNOTY PRIJIMANEHO BITU
        SETB    C
NO1RX:  RRC     A
        MOV     BYTERX,A        ;UCHOVAJ MODIFIKOVANY PRIJIMANY BYTE
        DJNZ    R0,OTBIT        ;TEST CI SU PRIJATE VSETKY BITY
        MOV     POC2L,#T1BL     ;PRIJEM 1 x 'STOP' BIT
        MOV     POC2H,#T1BH
STWA:   MOV     A,POC2L
        JNZ     STWA
        MOV     A,POC2H
        JNZ     STWA
        MOV     ERRORX,#55H     ;NASTAV PRIZNAK SPRAVNEHO PRIJMU BYTU !
        JB      RX,ISOKRX       ;TEST STOP BITU
RXERR:  MOV     ERRORX,#0AAH    ;NASTAV PRIZNAK CHYBNEHO PRIJMU BYTU
ISOKRX: POP     ACC             ;OBNOV ULOZENE PARAMETRE
        POP     PSW
        POP     R00
        RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TXSTAT: MOV     POC2L,#T1SL     ;NASTAV CAS CAKANIA ODPOVEDE NA max. 1 s
        MOV     POC2H,#T1SH
TXSTAV: JNB     TI,$            ;KOMUNIKACNY PROTOKOL PRI VYSIELANI STAVU RETRANSLATORA
        CLR     TI              ;CAKA NA POVOLENIE VYSIELANIA DO 'PC'
        CLR     RI              ;NULUJ PRIZNAK PRIJMU
        MOV     SBUF,KANAL      ;VYSLI CISLO KANALU
W1S:    MOV     A,POC2L
        JNZ     W1SX
        MOV     A,POC2H
        JNZ     W1SX
RENA:   MOV     BYTETX,#MUXNAK  ;SPRAVA DO 'RET', ZE MA UKONCIT CAKANIE NA ODPOVED Z 'MUX'
        CALL    TXBYTE          ;A MOZE POKRACOVAT V TESTOVANI STAVU OBJEKTOV
        RET                     ;NAVRAT PRI CHYBE
W1SX:   JNB     RI,W1S
        CLR     RI              ;NULUJ PRIZNAK PRIJMU
        MOV     A,SBUF          ;NACITAJ PRIJATU ODPOVED Z 'PC'
        CJNE    A,#PCYES,TXSTAV ;POZIADAVKA NA OPAKOVANIE VYSIELANIA AK JE CHYBA
OPAK0:  JNB     TI,$            ;TEST CI MOZEM VYSIELAT DO 'PC'
        CLR     TI
        MOV     SBUF,BYTERX     ;VYSLI PRIJATY UDAJ Z 'RET' DO 'PC'
        MOV     POC2L,#T100ML   ;NASTAV CAS CAKANIA ODPOVEDE Z 'PC' NA 100 ms
        MOV     POC2H,#T100MH
W2S:    MOV     A,POC2L
        JNZ     W2SX
        MOV     A,POC2H
        JNZ     W2SX
        LJMP    RENA            ;UKONCI CAKACI STAV 'RET' NA ODPOVED Z 'MUX'
W2SX:   JNB     RI,W2S          ;TEST CI UZ PRISLA ODPOVED Z 'PC'
        CLR     RI
        MOV     A,SBUF
        CJNE    A,#PCACK,NOACK  ;TEST CI IDE O PRENOS BUFFRA Z 'PC'
        MOV     BYTETX,#MUXACK  ;UKONCI CAKACI STAV 'RET' NA ODPOVED Z 'MUX'
        CALL    TXBYTE          ;'RET' MOZE DALEJ TESTOVAT OBJEKTY - NECAKA ZBYTOCNE
        RET                     ;AK PRIDE UAJ < AA TAK IDE O PRENOS DAT DO 'RET' !!!
NOACK:  CJNE    A,#PCNAK,NONAK
        LJMP    PRODAL          ;POKRACUJE V PROTOKOLE
NONAK:  LJMP    RENA            ;NESPRAVNE POTVRDENIE Z 'PC' - UKONCI PROTOKOL
PRODAL: CLR     LED             ;GREEN LED SIGNALIZUJE KOMUNIKACIU 'RET' S 'PC'
        MOV     POC2L,#T100ML   ;NASTAV CAS CAKANIA DALSIEHO BYTU Z 'PC' NA 100 ms
        MOV     POC2H,#T100MH
W3S:    MOV     A,POC2L
        JNZ     W3SX
        MOV     A,POC2H
        JNZ     W3SX
        LJMP    RENA            ;UKONCI CAKACI STAV 'RET' NA ODPOVED Z 'MUX'
W3SX:   JNB     RI,W3S
        CLR     RI
        MOV     BCC,#00         ;NULUJ PRIZNAK 'BCC' - KONTROLNY SUCET
        MOV     LONGBU,SBUF     ;ULOZ PRIJATY POCET BYTOV PRE SPRAVU Z 'PC'
        MOV     DPTR,#PCBUF     ;NASTAV POCIATOCNU ADRESU PRIJIMACIEHO BUFFRA
OPAK2:  MOV     POC2L,#T100ML   ;NASTAV CAS CAKANIA NA PRIJEM DALSIEHO BYTU Z 'PC'
        MOV     POC2H,#T100MH
W4S:    MOV     A,POC2L
        JNZ     W4SX
        MOV     A,POC2H
        JNZ     W4SX
        LJMP    RENA            ;UKONCI CAKACI STAV 'RET' NA ODPOVED Z 'MUX'
W4SX:   JNB     RI,W4S
        CLR     RI
        MOV     A,SBUF          ;ULOZ PRIJATY UDAJ DO PRIJIMACIEHO BUFFRA
        XRL     BCC,A           ;PO PRIJATI VSETKYCH BYTOV JE 'BCC=00'
        MOVX    @DPTR,A         ;ULOZ DO RWM EXTERNEJ
        MOV     A,DPLR          ;TEST CI SU PRIJATE VSETKY BYTY - VRATANE 'BCC'
        XRL     A,LONGBU
        JZ      OPAK3
        INC     DPTR
        LJMP    OPAK2           ;SKOK NA PRIJEM VSETKYCH BYTOV Z 'PC'
OPAK3:  JNB     TI,$            ;TEST CI MOZEM VYSIELAT DO 'PC'
        CLR     TI
        MOV     SBUF,#PCYES     ;VYSLE POTVRDENIE PRIJMU SPRAVY DO 'PC'
ZTXBUF: MOV     BYTETX,LONGBU   ;VYSLI POCET BYTOV SPRAVY DO 'RET'
        CALL    TXBYTE
        MOV     POC2L,#T300ML   ;CAKAJ max. 300 ms NA POTVRDENIE Z 'RET'
        MOV     POC2H,#T300MH
        CALL    RXBYTE
        MOV     POCPER,#00H     ;CAKAJ cca. 10 ms NA USTALENIE PRIEBEHU 'RX'
W10MS2: MOV     A,#O10M         ;NASTAV POCITADLO ONESKORENIA
        ADD     A,POCPER
        JNC     W10MS2
        JNB     RX,ISER1        ;TEST CI JE 'RX' V PORIADKU
        MOV     A,ERRORX        ;TESTOVANIE CI PRIJEM JE OK ALEBO CHYBA !
        CJNE    A,#0AAH,DALEJ0
ISER1:  RET                     ;NAVRAT PRI CHYBE - UKONCENIE KOMUNIKACNEHO PROTOKOLU
DALEJ0: MOV     A,BYTERX        ;NACITAJ PRIJATE POTVRDENIE Z 'RET', PRE POKRACOVANIE MUSI BYT 'REACK'
        CJNE    A,#REACK,ISER1
        MOV     POCPER,#00H     ;NASTAV POCITADLO ONESKORENIA cca. 10 ms
W10MX:  MOV     A,#O10M
        ADD     A,POCPER
        JNC     W10MX
        MOV     DPTR,#PCBUF     ;NASTAV ADRESU RWM PRIJATYCH BYTOV Z 'PC'
SEBUF:  MOV     POCPER,#00H
SEBU1:  MOV     A,#O10M         ;PRED VYSLANIM KAZDEHO BYTU CAKA cca. 10 ms
        ADD     A,POCPER
        JNC     SEBU1
        MOVX    A,@DPTR
        MOV     BYTETX,A        ;VYSLI UDAJ Z PRIJIMACIEHO BUFFRA DO 'RET'
        CALL    TXBYTE
        MOV     A,DPLR          ;TEST CI SU VYSLANE VSETKY BYTY
        XRL     A,LONGBU
        JZ      ISALLB
        INC     DPTR            ;DALSI BYTE SPRAVY
        LJMP    SEBUF
ISALLB: MOV     POC2L,#T300ML   ;CAKAJ max. 300 ms NA POTVRDENIE PRIJMU SPRAVY Z 'RET'
        MOV     POC2H,#T300MH
        CALL    RXBYTE
        MOV     A,ERRORX        ;TEST SPRAVNOSTI PRIJMU
        CJNE    A,#0AAH,DALEJ1
ISER3:  RET                     ;KONIEC PROTOKOLU PRI CHYBE KOMUNIKACIE
DALEJ1: MOV     POCPER,#00H     ;CAKAJ cca. 10 ms NA USTALENIE PRIEBEHU 'RX'
W10MS3: MOV     A,#O10M         ;NASTAV POCITADLO ONESKORENIA
        ADD     A,POCPER
        JNC     W10MS3
        JNB     RX,ISER3        ;TEST CI JE 'RX' V PORIADKU
        MOV     A,BYTERX        ;TEST CI JE POTVRDENIE OK ALEBO CHYBA !
        MOV     B,#0CDH         ;PRIZNAK 'CHYBA' PRI PROTOKOLE
        CJNE    A,#ACK,SECC
        MOV     B,#0CCH         ;PRIZNAK 'OK' PRI PROTOKOLE
SECC:   JNB     TI,$            ;VYSLI DO 'PC' SPRAVNOST POTVRDENIA Z 'RET'
        CLR     TI
        MOV     SBUF,KANAL      ;VYSLI CISLO AKTIVNEHO KANALU 'RET' DO 'PC'
        MOV     POC2L,#T1SL     ;CAKAJ max. 1 s NA POTVRDENIE Z 'PC'
        MOV     POC2H,#T1SH
W6S:    MOV     A,POC2L
        JNZ     W6SX
        MOV     A,POC2H
        JNZ     W6SX
        RET                     ;NAVRAT PRI CHYBE
W6SX:   JNB     RI,W6S
        CLR     RI
        MOV     A,SBUF          ;TEST SPRAVNOSTI POTVRDENIA PRIJMU CISLA KANALU
        CJNE    A,#PCYES,SECC
KOLOCC: JNB     TI,$            ;VYSLANIE PRIZNAKU PREBRATIA SPRAVY
        CLR     TI
        MOV     SBUF,B
        MOV     POC2L,#T300ML   ;CAKAJ max. 300 ms NA POVRDENIE Z 'PC'
        MOV     POC2H,#T300MH
W7S:    MOV     A,POC2L
        JNZ     W7SX
        MOV     A,POC2H
        JNZ     W7SX
        RET
W7SX:   JNB     RI,W7S
        CLR     RI
        MOV     A,SBUF          ;TEST SPRAVNOSTI POTVRDENIA
        CJNE    A,#PCYES,KOLOCC
        RET                     ;KONIEC KOMUNIKACNEHO PROTOKOLU
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TXBUF:  MOV     LONRET,BYTERX   ;KOMUNIKACNY PROTOKOL PRI PRIJME BUFFRA Z RETRANSLATORA
        MOV     POCPER,#00H     ;CAKAJ cca. 10 ms NA USTALENIE PRIEBEHU 'RX'
W10MS4: MOV     A,#O10M         ;NASTAV POCITADLO ONESKORENIA
        ADD     A,POCPER
        JNC     W10MS4
        JNB     RX,RCHY         ;TEST CI JE 'RX' V PORIADKU
        MOV     BYTETX,#ACK     ;POTVRDENIE DO 'RET' KOMUNIKACIU
        CALL    TXBYTE
        JB      RX,RDAL         ;KONTROLA CI RX = 1, POSLEDNY BOL VYSIELANY STOP BIT NA 'TX'
RCHY:   RET                     ;NAVRAT S CHYBOU
RDAL:   MOV     DPTR,#RETBUF    ;NASTAV ZACIATOK PRIJIMACIEHO BUFFRA Z 'RET'
ROPAK:  MOV     POC2L,#T300ML   ;NASTAV CAKANIE 300 ms NA PRIJEM POTVRDENIA Z 'RET'
        MOV     POC2H,#T300MH
        CALL    RXBYTE
        MOV     A,ERRORX        ;TEST NA CHYBU PRIJMU Z 'RET'
        CJNE    A,#055H,RCHY    ;SKOK PRI CHYBE - NAVRAT
        MOV     A,BYTERX        ;ZISTI AKY JE NACITANY BYTE Z 'RET'
        MOVX    @DPTR,A         ;ULOZ BYTE DO PRIJIMACIEHO BUFFRA
        MOV     A,LONRET        ;ZISTI CI SU PRIJATE VSETKY BYTY Z 'RET' + BCC + LINKA
        INC     A
        XRL     A,DPLR
        JZ      RS10
        INC     DPTR            ;NASTAV DALSIU ADRESU PRIJIMACIEHO BUFFRA V RWM
        LJMP    ROPAK
RS10:   MOV     POCPER,#00H     ;CAKAJ cca. 10 ms NA USTALENIE PRIEBEHU 'RX'
W10MS5: MOV     A,#O10M         ;NASTAV POCITADLO ONESKORENIA
        ADD     A,POCPER
        JNC     W10MS5
        JNB     RX,RCHY         ;TEST CI JE 'RX' V PORIADKU
        MOV     POC2L,#T1SL     ;CAKAJ NA ODPOVED Z 'PC' max. 1 s
        MOV     POC2H,#T1SH
RS11:   JNB     TI,$            ;CAKAJ NA POVOLENIE VYSIELAT DO 'PC'
        CLR     TI
        CLR     RI
        MOV     SBUF,KANAL      ;VYSLI CISLO AKTIVNEHO KANALU
W1R:    MOV     A,POC2L
        JNZ     W1RX
        MOV     A,POC2H
        JNZ     W1RX
        LJMP    RENA            ;VYSLI DO 'ATU' KOD 'MUXNAK' - 'MUX' NENADVIAZAL SPOJENIE S 'PC'
W1RX:   JNB     RI,W1R
        CLR     RI
        MOV     A,SBUF          ;NACITAJ AKA JE ODPOVED Z 'PC'
        CJNE    A,#PCYES,RS11
RS2:    JNB     TI,$            ;CAKA NA POVOLENIE VYSIELANIA DO 'PC'
        CLR     TI
        MOV     SBUF,LONRET     ;VYSLI POCET BYTOV SPRAVY Z 'RET' DO 'PC'
        MOV     POC2L,#T100ML   ;CAKAJ 100 ms NA POTVRDENIE KOMUNIKACIE
        MOV     POC2H,#T100MH
W2R:    MOV     A,POC2L
        JNZ     W2RX
        MOV     A,POC2H
        JNZ     W2RX
ST01:   LJMP    RENA            ;VYSLI DO 'ATU' KOD 'MUXNAK' - 'MUX' NENADVIAZAL SPOJENIE S 'PC'
W2RX:   JNB     RI,W2R
        CLR     RI              ;TEST TYPU ODPOVEDE Z 'PC'
        MOV     A,SBUF
        CJNE    A,#PCYES,ST01
        MOV     DPTR,#RETBUF    ;NASTAV POCIATOCNU ADRESU PRIJIMACIEHO BUFFRA Z 'RET'
RS3:    JNB     TI,$            ;CAKAJ NA POVOLENIE VYSIELANIA DO 'PC'
        CLR     TI
        MOVX    A,@DPTR         ;NACITAJ VYSIELANY UDAJ Z PAMATE
        MOV     SBUF,A          ;A VYSLI DO 'PC'
        MOV     A,LONRET        ;SKONTROLUJ CI JE VYSLANA CELA SPRAVA + BCC + LINKA
        INC     A
        XRL     A,DPLR
        JZ      ALLTX
        INC     DPTR
        LJMP    RS3
ALLTX:  MOV     POC2L,#T300ML   ;CAKA 300 ms NA ODPOVED Z 'PC'
        MOV     POC2H,#T300MH
W3R:    MOV     A,POC2L
        JNZ     W3RX
        MOV     A,POC2H
        JNZ     W3RX
RNEX:   LJMP    RENA            ;VYSLI DO 'ATU' KOD 'MUXNAK' - 'MUX' NENADVIAZAL SPOJENIE S 'PC'
W3RX:   JNB     RI,W3R
        CLR     RI              ;TEST TYPU POTVRDENIA (ACK,NAK ?)
        MOV     A,SBUF
        CJNE    A,#PCACK,NPACK
        MOV     BYTETX,#ACK     ;VYSLI SPRAVNOST PREVZATIA SPRAVY DO 'RET'
        CALL    TXBYTE          ;'RET' CAKA NA TOTO POTVRDENIE min. 1.5 sek.
        JB      RX,RDAL06       ;TEST CI NA RX=1, POSLEDNY SA VYSIELAL STOP BIT
        RET
RDAL06: MOV     POC2L,#T300ML   ;CAKAJ 300 ms NA POTVRDENIE KONCA PROTOKOLU
        MOV     POC2H,#T300MH
        CALL    RXBYTE
        MOV     POCPER,#00H     ;CAKAJ cca. 10 ms NA USTALENIE PRIEBEHU 'RX'
W10MS6: MOV     A,#O10M         ;NASTAV POCITADLO ONESKORENIA
        ADD     A,POCPER
        JNC     W10MS6
        JNB     RX,RNE2         ;TEST CI JE 'RX' V PORIADKU
        MOV     A,ERRORX
        CJNE    A,#0AAH,RNE1    ;SKOK AK NIE JE CHYBA PRIJMU
        RET                     ;UKONCI PROTOKOL AK POTVRDENIE NEPRISLO ALEBO BOLA CHYBA
RNE1:   MOV     A,BYTERX        ;UKONCI PROTOKOL PRI PRIJME LUBOVOLNEHO ZNAKU !
        CJNE    A,#REACK,RNE2   ;PRIJATY ZNAK BY SPRAVNE MAL BYT 'REACK'
RNE2:   RET
NPACK:  CJNE    A,#PCNAK,RNEX   ;AK JE NESPRAVNE POTVRDENIE UKONCI PROTOKOL S 'RET'
        CLR     LED             ;GREEN LED SIGNALIZUJE KOMUNIKACIU 'RET' S 'PC'
        MOV     POC2L,#T100ML   ;NASTAV CAS CAKANIA DALSIEHO BYTU Z 'PC' NA 100 ms
        MOV     POC2H,#T100MH   ;'RET' MUSI CAKAT NA POTVRDENIE PREBRATIA UDAJOV min. 1.5s
RW3S:   MOV     A,POC2L
        JNZ     RW3SX
        MOV     A,POC2H
        JNZ     RW3SX
        LJMP    RENA            ;VYSLI DO 'ATU' KOD 'MUXNAK' - 'MUX' NENADVIAZAL SPOJENIE S 'PC'
RW3SX:  JNB     RI,RW3S
        CLR     RI
        MOV     BCC,#00         ;NULUJ PRIZNAK 'BCC' - KONTROLNY SUCET
        MOV     LONGBU,SBUF     ;ULOZ PRIJATY POCET BYTOV PRE SPRAVU Z 'PC'
        MOV     DPTR,#PCBUF     ;NASTAV POCIATOCNU ADRESU PRIJIMACIEHO BUFFRA
ROPAK2: MOV     POC2L,#T100ML   ;NASTAV CAS CAKANIA NA PRIJEM DALSIEHO BYTU Z 'PC'
        MOV     POC2H,#T100MH
RW4S:   MOV     A,POC2L
        JNZ     RW4SX
        MOV     A,POC2H
        JNZ     RW4SX
        LJMP    RENA            ;VYSLI DO 'ATU' KOD 'MUXNAK' - 'MUX' NENADVIAZAL SPOJENIE S 'PC'
RW4SX:  JNB     RI,RW4S
        CLR     RI
        MOV     A,SBUF          ;ULOZ PRIJATY UDAJ DO PRIJIMACIEHO BUFFRA
        XRL     BCC,A           ;PO PRIJATI VSETKYCH BYTOV JE 'BCC=00'
        MOVX    @DPTR,A         ;ULOZ DO RWM EXTERNEJ
        MOV     A,DPLR          ;TEST CI SU PRIJATE VSETKY BYTY - VRATANE 'BCC'
        XRL     A,LONGBU
        JZ      ROPAK3
        INC     DPTR
        LJMP    ROPAK2          ;SKOK NA PRIJEM VSETKYCH BYTOV Z 'PC'
ROPAK3: JNB     TI,$            ;TEST CI MOZEM VYSIELAT DO 'PC'
        CLR     TI
        MOV     SBUF,#PCYES     ;VYSLE POTVRDENIE PRIJMU SPRAVY DO 'PC'
        MOV     BYTETX,#NAK     ;VYSLI POTVRDENIE SIGNALIZUJUCE POZIADAVKU PRENOSU SPRAVY
        CALL    TXBYTE          ;Z 'PC' DO 'RET'
        JB      RX,RDAL15       ;TEST CI NA RX=1, POSLEDNY SA VYSIELAL STOP BIT
        RET
RDAL15: MOV     POC2L,#T300ML   ;CAKA 300 ms NA POTVRDENIE Z 'RET'. 'RET' MUSI OTESTOVAT
        MOV     POC2H,#T300MH   ;CI MA PRAZDNY PRIJIMACI BUFFER A PODLA VYSLEDKU DA ODPOVED
        CALL    RXBYTE          ;!!! IDE O ZMENU OPROTI POVODNEMU KOMUNIKACNEMU PROTOKOLU
        MOV     POCPER,#00H     ;CAKAJ cca. 10 ms NA USTALENIE PRIEBEHU 'RX'
W10MS7: MOV     A,#O10M         ;NASTAV POCITADLO ONESKORENIA 10 ms
        ADD     A,POCPER
        JNC     W10MS7
        JNB     RX,NORET        ;TEST CI JE 'RX' V PORIADKU
        MOV     A,ERRORX        ;TEST NA CHYBU PRIJMU, UKONCI AK NIC NEPRIDE ALEBO JE CHYBA
        CJNE    A,#0AAH,RNE3
NORET:  RET
RNE3:   MOV     A,BYTERX        ;NACITAJ PRIJATY BYTE Z 'ATU'
        CJNE    A,#REACK,NORET  ;SKOK NA UKONCENIE AK JE PRIJIMACI BUFFER 'RET' PLNY
        MOV     POCPER,#00H     ;CAKAJ cca. 30 ms NA USTALENIE PRIEBEHU 'RX'
W10MS8: MOV     A,#O30M         ;NASTAV POCITADLO ONESKORENIA 30 ms (USTALENIE NA LINKE)
        ADD     A,POCPER
        JNC     W10MS8
        LJMP    ZTXBUF          ;VYSLI SPRAVU Z BUFFRA 'MUX' DO 'RET' - PRIJIMACI BUF. 'RET' JE PRAZDNY
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MAIN:   NOP                     ;HLAVNA SLUCKA PROGRAMU
        MOV     A,POC1L         ;TEST CI UPLYNUL CAS > 5s PRE VYSIELANIE KODU 'DD'
        JNZ     TKAN0
        MOV     A,POC1H
        JZ      TDD
TKAN0:  LJMP    TKAN            ;SKOK NA OBSLUHU AKTIVNEHO KANALU (BYTE KANAL)
TDD:    CLR     RI              ;NULUJ PRIZNAK PRIJATEHO BYTU Z IBM PC
DDCAKA: JNB     TI,$            ;POKIAL NEMOZEM VYSIELAT DO IBM PC CAKA
        CLR     TI
        MOV     SBUF,#MUX       ;VYSLI PRIZNAK AKTIVNEHO 'MUXu'
        MOV     POC2L,#T1SL     ;NASTAV CAS CAKANIA max. 1 SEKUNDU NA ODPOVED
        MOV     POC2H,#T1SH
RIWAIT: MOV     A,POC2L         ;TEST CI UPLYNUL MAXIMALNY CAS CAKANIA ODPOVEDE
        JNZ     TKAN1
        MOV     A,POC2H
        JNZ     TKAN1
DDWAIT: SETB    LED             ;VYPNI GREEN LED DIODU
        CLR     SIRENA          ;ZAPNI SIRENU - STRATA KOMUNIKACIE S IBM PC
        LJMP    DDCAKA          ;POKUS ZNOVA NADVIAZAT KOMUNIKACIU
TKAN1:  JNB     RI,RIWAIT       ;TEST CI JE ODPOVED PRIJATA
        CLR     RI
        MOV     A,SBUF
        XRL     A,#PCYES
        JNZ     DDWAIT          ;OPAKUJE AK NIE JE SPRAVNA ODPOVED
        SETB    SIRENA          ;VYPNI SIRENU
        MOV     POC1L,#SPOC1L   ;NASTAV POCITADLO DOBY VIAC AKO 5 s
        MOV     POC1H,#SPOC1H
        MOV     KANACK,#0FFH    ;NASTAV POZIADAVKU NA KOMUNIKACIU 'KANAL' S 'PC'
TKAN:   MOV     A,#0F9H         ;TEST NA POSLEDNY KANAL (KANAL > 6 - JE KASKADA ?)
        ADD     A,KANAL         ;CISLO 'KANAL' JE V ROZSAHU (1 - 7)
        JNC     NOBIG
        MOV     KANAL,#00H
NOBIG:  INC     KANAL
        LJMP    PROTOK          ;KOMUNIKACNY PROTOKOL S RETRANSLATOROM AKTIVNEHO KANALA
;===================================================
;ZACIATOK HLAVNEHO PROGRAMU
;
RESTA:  LJMP    TESTS           ;SKOK NA INICIALIZACNE TESTY uP A INTERNEJ 'RWM'
EEPROM: NOP
;       LJMP    INICI           ;NETESTUJE EEPROM (PODLA VERZIE 'SW')
        LJMP    EETEST          ;TESTUJE EEPROM   (PODLA VERZIE 'SW')
INICI:  LJMP    INIC            ;SKOK NA INICIALIZACIU PARAMETROV SW A HW
KOLO:   LJMP    MAIN
;
;KONIEC HLAVNEHO PROGRAMU
;===================================================
;
        DB      'END - muxspin - '

;
        END
;